-- SPDX-License-Identifier: CC0-1.0

let Genode = env:DHALL_GENODE

in    λ(boot : Genode.Boot.Type)
    → { config =
          Genode.Init::{
          , defaultRoutes =
                Genode.Init.default.defaultRoutes
              # [ Genode.ServiceRoute.parent "IO_MEM"
                , Genode.ServiceRoute.parent "IO_PORT"
                , Genode.ServiceRoute.parent "IRQ"
                , Genode.ServiceRoute.child "Timer" "timer"
                ]
          , children =
              [ { mapKey = "timer"
                , mapValue =
                    Genode.Init.Start::{
                    , binary = "hw_timer_drv"
                    , resources = { caps = 96, ram = Genode.units.MiB 1 }
                    , provides = [ "Timer" ]
                    }
                }
              , { mapKey = "harness"
                , mapValue = Genode.Init.toStart boot.config
                }
              ]
          }
      , rom =
          let manifest = env:MANIFEST
          
          in    Genode.Boot.toRomPaths
                  [ manifest.base-hw-pc.lib.ld
                  , manifest.base-hw-pc.bin.hw_timer_drv
                  , manifest.os.bin.init
                  ]
              # boot.rom
      }
